program TestSHRotate
!------------------------------------------------------------------------------
!
!    This program will read in a spherical harmonic file, then rotate
!    the body by the three euler angles.
!
!    Copyright (c) 2005, SHTOOLS
!    All rights reserved.
!
!------------------------------------------------------------------------------
    use SHTOOLS
    use ftypes

    implicit none

    real(dp) :: x(3), pi, interval, alpha, beta, gamma
    real(dp), allocatable :: cilm1(:,:,:), cilm2(:,:,:), dj(:,:,:), grid(:,:)
    character(240) :: outsh, outgrid, infile
    integer(int32) :: lmax, nlat, nlong, i, j, l, m, bodycoord, astat(4)

    pi = acos(-1.0_dp)

    lmax = 719
    allocate(cilm1(2, lmax+1, lmax+1), stat = astat(1))
    if (astat(1) /= 0) then
        print*, "Problem allocating arrays"
        stop
    end if

    ! Path to example data files may be passed as first argument, or use a default.
    if (command_argument_count() > 0) then
        call get_command_argument(1, infile)
    else
        infile = "../../ExampleDataFiles"
    end if
    infile = trim(infile) // "/MarsTopo719.shape"
    print*, "Input file = ", infile
    call SHRead(infile, cilm1, lmax)
    print*, "Lmax of input file = ", lmax

    ! A data input file may be passed as second argument, or else prompt for required settings.
    if (command_argument_count() > 1) then
        call get_command_argument(2, infile)
        open(unit=20, file=infile, action="read")
        read(20,*) lmax
        read(20,*) alpha
        read(20,*) beta
        read(20,*) gamma
        read(20,*) bodycoord
        read(20,*) outsh
        read(20,*) interval
        read(20,*) outgrid
        close(20)
    else
        print*, "Maximum degree to be used with rotations > "
        read(*,*) lmax

        print*, "Input Euler Angles"
        print*, "Alpha (deg) = "
        read(*,*) alpha
        print*, "Beta (deg) = "
        read(*,*) beta
        print*, "Gamma (deg) = "
        read(*,*) gamma

        print*, "Do these correspond to "
        print*, "(1) Rotation of the coordinate system without rotation of the physical body, or"
        print*, "(2) Rotation of the physical body without rotation of the coordinate system."
        read(*,*) bodycoord

        print*, "Output file name of rotated spherical harmonics > "
        read(*,*) outsh

        print*, "Grid spacing for output grid (deg) > "
        read(*,*) interval
        print*, "File name of gridded rotated field > "
        read(*,*) outgrid
    end if

    if (bodycoord ==1) then
        x(1) = alpha ; x(2) = beta ; x(3) = gamma
    elseif (bodycoord ==2) then
        x(1) = -gamma ; x(2) = -beta ; x(3) = -alpha
    else
        print*, "Must enter 1 or 2"
        stop
    end if

    x = x * pi / 180.0_dp

    allocate(cilm2(2, lmax+1, lmax+1), stat = astat(2))
    allocate(dj(lmax+1, lmax+1, lmax+1), stat = astat(3))
    nlat = 180.0_dp / interval + 1
    nlong = 360.0_dp / interval + 1
    allocate(grid(nlat,nlong), stat = astat(4))

    if (sum(astat(2:4)) /= 0) then
        print*, "Problem allocating arrays"
        stop
    end if

    !--------------------------------------------------------------------------
    !
    !    Rotate coefficients to a specific coordinate
    !
    !--------------------------------------------------------------------------

    print*, "Computing rotation matrix"
    call djpi2(dj, lmax)    ! Create rotation matrix used in the rotation routine.

    print*, "Rotating spherical harmonics"
    call SHRotateRealCoef(cilm2, cilm1, lmax, x, dj)

    print*, "Making 2D grid"
    call MakeGrid2d(grid, cilm2, lmax, interval, nlat, nlong)

    !--------------------------------------------------------------------------
    !
    !    Output data to disk
    !
    !--------------------------------------------------------------------------

    open(12,file=outsh)
    do l = 0, lmax
        do m = 0, l
            write(12,*) l, m, cilm2(1,l+1,m+1), cilm2(2,l+1,m+1)
        end do
    end do
    close(12)

    open(13, file=outgrid)
    write(13,*) nlat, nlong

    do i = 1, nlat
        do j = 1, nlong
            write(13,*) grid(i,j)
        end do
    end do
    close(13)

    deallocate(cilm1)
    deallocate(cilm2)
    deallocate(dj)
    deallocate(grid)

end program TestSHRotate

Program LocalizedAdmitCorr
!------------------------------------------------------------------------------
!
!    This program demonstrates how to calculate localized admittance and
!    correlation functions.
!
!    Copyright (c) 2005, SHTOOLS
!    All rights reserved.
!
!------------------------------------------------------------------------------
    use SHTOOLS
    use PlanetsConstants
    use ftypes

    implicit none

    character(240) :: infile, topography_file, potential_file, outfile
    real(dp) :: header(8), mpr,  r0_pot, gm, mass, lat, lon, pi, theta0, &
                alpha, sn, r
    real(dp), allocatable :: grav(:,:,:), admit(:), corr(:), admit_error(:), &
                             corr_error(:), tapers(:,:), eigenvalues(:), &
                             topo(:,:,:), pot(:,:,:)
    integer(int32) :: lmax_topo, lmax_pot, lmax, option1, l, lwin, lmaxwin, &
                      astat(5), K, degmax
    integer(int32), allocatable :: taper_order(:)

    pi = acos(-1.0_dp)

    degmax = 360

    ! Path to example data files may be passed as first argument, or use a default.
    if (command_argument_count() > 0) then
        call get_command_argument(1, infile)
    else
        infile = "../../ExampleDataFiles"
    end if
    topography_file = trim(infile) // "/MarsTopo719.shape"
    potential_file = trim(infile) // "/gmm3_120_sha.tab"

    !--------------------------------------------------------------------------
    !
    !   Read topography and gravity fields, and from the header information
    !   determine the mean planetary radius and mass. Verify that these values
    !   are correct as it is possible the input files could be using a
    !   different set of base units (i.e., km instead of meters).
    !
    !--------------------------------------------------------------------------

    allocate(topo(2,degmax+1,degmax+1), stat = astat(1))
    allocate(pot(2,degmax+1,degmax+1), stat = astat(2))
    if (astat(1) /= 0 .or. astat(2) /= 0) then
        print*, "Problem allocating arrays TOPO and POT", astat(1), astat(2)
        stop
    end if

    print*, "Reading = ", topography_file
    call SHRead(topography_file, topo, lmax_topo)

    print*, "Lmax of topography file = ", lmax_topo

    mpr = topo(1,1,1)
    print*, "Mean planetary radius (km) = ", mpr  /1.e3_dp

    print*, "Reading = ", potential_file
    call SHRead(potential_file, pot, lmax_pot, header=header(1:2))

    print*, "Lmax of potential file = ", lmax_pot

    r0_pot = header(1) * 1.e3_dp
    gm = header(2) * 1.e9_dp
    mass = gm/Grav_constant

    print*, "Reference radius of potential coefficients (km) = ", r0_pot / 1.e3_dp

    print*, "Mass of planet (kg) = ", mass
    print*, "Surface gravitational acceleration (m/s2) = ", gm / r0_pot**2

    lmax = min(lmax_topo, lmax_pot)
    print*, "Maximum spherical harmonic degree to be used in calculations = ", lmax

    !--------------------------------------------------------------------------
    !
    !    Get localization parameters from user.
    !
    !--------------------------------------------------------------------------

    ! A data input file may be passed as second argument, or else prompt for required settings.
    if (command_argument_count() > 1) then
        call get_command_argument(2, infile)
        open(unit=20, file=infile, action="read")
        read(20,*) K
        read(20,*) lat
        read(20,*) lon
        read(20,*) theta0
        read(20,*) option1
        if (option1==1) then
            read(20,*) alpha
        else if (option1==2) then
            read(20,*) sn
        else if (option1==3) then
            read(20,*) lwin
        else
            stop
        end if
        read(20,*) outfile
        close(20)
    else
        print*, "Number of tapers to use > "
        read(*,*) K

        print*, "Latitude of feature of interest (degrees) > "
        read(*,*) lat
        print*, "Longitude (degrees) > "
        read(*,*) lon
        print*, "Angular radius of localization window (degrees) > "
        read(*,*) theta0
        theta0 = theta0*pi / 180.0_dp

        print*, "Create localization window using"
        print*, "(1) Desired concentration factor, alpha"
        print*, "(2) Desired (approximate) Shannon number; (Lwin+1) Theta0 / pi)"
        print*, "(3) Desired Spectral bandwidth (Lwin)"
        read(*,*) option1

        if (option1==1) then
            print*, "Input desired concentration factor of the Kth taper > "
            read(*,*) alpha
        else if (option1==2) then
            print*, "Input Shannon number > "
            read(*,*) sn
        else if (option1==3) then
            print*, "Input Lwin > "
            read(*,*) lwin
        else
            stop
        end if

        print*, "Name of output admittance and correlation file > "
        read(*,*) outfile
    end if

    allocate(tapers(lwin+1, (lwin+1)**2), stat = astat(1))
    allocate(taper_order((lwin+1)**2), stat = astat(2))
    allocate(eigenvalues((lwin+1)**2), stat = astat(3))

    if (astat(1) /= 0 .or. astat(2) /= 0 .or. astat(3) /= 0 ) then
        print*, "Problem allocatig arrays for tapers, taper_order, or eigenvalues", &
                astat(1), astat(2), astat(3)
        stop
    end if

    call SHReturnTapers(theta0, lwin, tapers, eigenvalues, taper_order)

    print*, "Concentration factor of first taper = ", eigenvalues(1)
    print*, "Taper order = ", taper_order(1)

    lmaxwin = lmax + lwin

    r = r0_pot

    print*, "Gravity field evaluated at R = (km) ", r0_pot / 1.e3_dp

    if (option1==1) then
        lwin = SHFindLWin(theta0, 0, alpha, K)
        print*, "Corresponding spherical harmonic bandwidth = ", lwin
        print*, "Corresponding approximate Shannon number = ", &
                (lwin+1) * theta0 / pi
    else if (option1==2) then
        lwin = nint(sn * pi / theta0) - 1
        print*, "Corresponding spherical harmonic bandwidth = ", lwin
    else if (option1==3) then
        print*, "Corresponding approximate Shannon number = ", &
                (lwin+1) * theta0 / pi
    else
        stop
    end if

    open(12, file=outfile)

    !--------------------------------------------------------------------------
    !
    !    Allocate memory for arrays based on Lmax and Lwin.
    !
    !--------------------------------------------------------------------------

    allocate(grav(2,lmax+1,lmax+1), stat=astat(1))
    allocate(admit(lmax+lwin+1), stat=astat(2))
    allocate(corr(lmax+lwin+1), stat=astat(3))
    allocate(admit_error(lmax+lwin+1), stat=astat(4))
    allocate(corr_error(lmax+lwin+1), stat=astat(5))

    grav = 0.0_dp
    admit = 0.0_dp
    corr = 0.0_dp
    admit_error = 0.0_dp
    corr_error = 0.0_dp

    if (astat(1) /= 0 .or. astat(2) /= 0 .or. astat(3) /= 0 .or. astat(4) /= 0 &
        .or. astat(5) /=0) then
        print*, "Problem allocating memory"
        stop
    end if

    !--------------------------------------------------------------------------
    !
    !    Create gravity coefficients in units of mGals. Convert Topography
    !    coefficients to km.
    !
    !    Cilm(gravity) = 1.d5*G*M*Cilm(potential)*(l+1)*(r0_pot/r)**(l+2)/r0_pot**2
    !
    !--------------------------------------------------------------------------

    do l = 0, lmax
        grav(1:2,l+1,1:l+1) = pot(1:2,l+1,1:l+1) * dble(l+1) * (r0_pot/r)**(l+2)
    end do

    grav = grav * 1.0e5_dp * gm / (r0_pot**2)
    topo = topo / 1.0e3_dp

    !--------------------------------------------------------------------------
    !
    !    Compute localized admittances, and write data to output file.
    !    Units for the admittance are mgals/km.
    !
    !--------------------------------------------------------------------------

    call SHLocalizedAdmitCorr(tapers, taper_order, lwin, lat, lon, grav, topo, &
        lmax, admit, corr, K, admit_error=admit_error, corr_error=corr_error, &
        mtdef=1)

    if (K == 1) then
        do l = 0, lmax - lwin
            write(12,*) l, admit(l+1), corr(l+1)
        end do
    else
        do l = 0, lmax - lwin
            write(12,*) l, admit(l+1), admit_error(l+1), corr(l+1), &
                        corr_error(l+1)
        end do
    end if

    close(12)

    deallocate(grav)
    deallocate(admit)
    deallocate(admit_error)
    deallocate(corr)
    deallocate(corr_error)
    deallocate(tapers)
    deallocate(taper_order)
    deallocate(eigenvalues)
    deallocate(topo)
    deallocate(pot)

end program LocalizedAdmitCorr

Program TimingAccuracyGLQC
!------------------------------------------------------------------------------
!
!    This program will test the accuracy of the spherical harmonic GLQ
!    tranformation routines by expanding a field in the space domain,
!    transforming this to spherical harmonics, and comparing the relative error
!    of the coefficients.
!
!    Copyright (c) 2005, SHTOOLS
!    All rights reserved.
!
!------------------------------------------------------------------------------
    use SHTOOLS
    use ftypes

    implicit none

    integer(int32), parameter :: maxdeg = 2800
    character(240) :: outfile1, outfile2, outfile3, outfile4, outfile, infile
    complex(dp), allocatable :: cilm(:,:,:), cilm2(:,:,:), gridglq(:,:)
    real(dp), allocatable :: zero(:), w(:)
    real(dp) :: maxerror, err1, err2, beta, rms, timein(3), timeout(3)
    integer(int32) :: lmax, l, m, seed, astat(5)

    allocate(cilm(2,maxdeg+1,maxdeg+1), stat=astat(1))
    allocate(cilm2(2,maxdeg+1,maxdeg+1), stat=astat(2))
    allocate(zero(maxdeg+1), stat=astat(3))
    allocate(gridglq(maxdeg+1,2*maxdeg+1), stat=astat(4))
    allocate(w(maxdeg+1), stat=astat(5))

    if (sum(astat(1:5)) /= 0) then
        print*, "Error --- TimingAccuracyGLQ"
        print*, "Problem allocating arrays CILM, CILM2, ZERO, GRIDGLQ, W"
        stop
    end if

    ! A data input file may be passed as the first argument. Otherwise prompt for required settings.
    if (command_argument_count() > 0) then
        call get_command_argument(1, infile)
        open(unit=20, file=infile, action="read")
        read(20,*) beta, outfile
        close(20)
    else
        print*, "Value of beta for power law Sff = l^(-beta) > "
        read(*,*) beta

        print*, "output file name > "
        read(*,*) outfile
    end if

    outfile1 = trim(outfile) // ".timef"
    outfile2 = trim(outfile) // ".timei"
    outfile3 = trim(outfile) // ".maxerror"
    outfile4 = trim(outfile) // ".rmserror"

    seed = -1053253

    cilm = cmplx(0.0_dp, 0.0_dp, dp)

    do l = 1, maxdeg

        do m = 0, l
            if (m == 0) then
                cilm(1,l+1,m+1) = cmplx(RandomGaussian(seed), &
                                        RandomGaussian(seed), dp)
            else
                cilm(1,l+1,m+1) = cmplx(RandomGaussian(seed), &
                                        RandomGaussian(seed), dp)
                cilm(2,l+1,m+1) = cmplx(RandomGaussian(seed), &
                                        RandomGaussian(seed), dp)
            end if
        end do
        cilm(1:2, l+1, 1:l+1) = cilm(1:2, l+1, 1:l+1) * sqrt(dble(l)**beta) &
                                / sqrt(2.0_dp * l + 1)
    end do

    print*, "Lmax, Maximum rel. error of Cilm, RMS relative error, Precompute time (sec), Time inverse (sec), Time forward (sec)"

    lmax = 1

    do

        lmax = lmax * 2
        if (lmax > maxdeg) lmax = maxdeg

        if (lmax == 2) then
            open(12,file=outfile1, status="replace")
            open(13,file=outfile2, status="replace")
            open(14,file=outfile3, status="replace")
            open(15,file=outfile4, status="replace")
        else
            open(12,file=outfile1, position="append")
            open(13,file=outfile2, position="append")
            open(14,file=outfile3, position="append")
            open(15,file=outfile4, position="append")
        end if

        call cpu_time(timein(1))
        call SHGLQ(lmax, zero(1:lmax+1), w(1:lmax+1))
        call cpu_time(timeout(1))

        call cpu_time(timein(2))
        call MakeGridGLQC(gridglq(1:lmax+1, 1:2*lmax+1), &
                          cilm(1:2,1:lmax+1, 1:lmax+1), lmax, &
                          zero=zero(1:lmax+1), norm=1)
        call cpu_time(timeout(2))

        call cpu_time(timein(3))
        call SHExpandGLQC(cilm2(1:2, 1:lmax+1, 1:lmax+1), lmax, &
                          gridglq(1:lmax+1, 1:2*lmax+1), w, &
                          zero=zero(1:lmax+1), norm=1)
        call cpu_time(timeout(3))

        maxerror = 0.0_dp
        rms = 0.0_dp

        do l = 1, lmax

            do m = 0, l
                if (m == 0) then
                    err1 = abs( (cilm(1,l+1,m+1) - cilm2(1,l+1,m+1)) ) / abs( cilm(1,l+1,m+1) )
                    if (err1 >= maxerror) maxerror = err1
                    rms = rms + err1**2
                else
                    err1 = abs( (cilm(1,l+1,m+1) - cilm2(1,l+1,m+1)) ) / abs( cilm(1,l+1,m+1) )
                    err2 = abs( (cilm(2,l+1,m+1) - cilm2(2,l+1,m+1)) ) / abs( cilm(2,l+1,m+1) )
                    if (err1 >= maxerror) maxerror = err1
                    if (err2 >= maxerror) maxerror = err2
                    rms = rms + err1**2 + err2**2
                end if
            end do
        end do
        rms = sqrt(rms / dble(l+1)**2)

        ! elasped time in seconds!
        print*, lmax, maxerror, rms, timeout(1)-timein(1), timeout(2)-timein(2), timeout(3)-timein(3)
        write(12,*) lmax, timeout(2)-timein(2)
        write(13,*) lmax, timeout(3)-timein(3)
        write(14,*) lmax, maxerror
        write(15,*) lmax, rms

        if (maxerror > 100.0_dp) then
            print*, "TESTS FAILED"
            print*, "Degree = ", lmax
            print*, "Maximum relative error = ", maxerror
            close(12)
            close(13)
            close(14)
            close(15)
            stop
        end if

        close(12)
        close(13)
        close(14)
        close(15)

        if (lmax == maxdeg) exit

    enddo

end program TimingAccuracyGLQC

program MarsCrustalThickness
!-------------------------------------------------------------------------------
!
!   This program will compute the relief along the crust-mantle interface that
!   is needed to explain the martian gravity field. This crustal thickness
!   model is "anchored" by chosing a minimum crustal thickness.
!
!   In this program, the maximum spherical harmonic degree that is used
!   when calculating the relief raised to the nth power is the input spherical
!   harmonic degree. This is not entirely correct, as the relief raised to the
!   nth power generates a spherical harmonic field up to lmax*n. However, as it
!   is also not correct to assume that the topo and gravity field are
!   bandlimited with a maximum spherical harmonic degree of lmax, this
!   approximation is probably ok, espeically considering that the iterations
!   are filtered.
!
!   In order to improve stability when iterating for the Moho relief, the
!   following iterative scheme is used:
!
!       h3 = (h2+h1)/2
!       h4 = f(h3)
!
!   where "h" represents the moho relife, and "f" represents the SHTOOLS
!   funcion "BAtoHilm".
!
!   Copyright (c) 2015, SHTOOLS
!   All rights reserved.
!
!-------------------------------------------------------------------------------
    use SHTOOLS
    use PLANETSCONSTANTS
    use ftypes

    implicit none

    real(dp) :: r0, mass, rho_crust, rho_mantle, pi, gm, thinnest(2), &
                d, t0, delta, delta_max, thick_delta, param(8), grav, &
                r_grav, interval, rref, timein, timeout, max_thick, min_thick
    real(dp), allocatable :: topo_grid(:,:), moho_grid(:,:), moho_grid2(:,:), &
                             moho_grid3(:,:), temp_grid(:,:), topo_c(:,:,:), &
                             moho_c(:,:,:), bc(:,:,:), ba(:,:,:), cilm(:,:,:), &
                             pot(:,:,:), misfit(:,:,:)
    integer(int32) :: l, m, lmax, i, nmax, nlat, nlong, gridtype, astat(12), &
                      n_out, iter, j, r1, lmaxp, lmaxt, filter_type, half, &
                      degmax, sampling
    character(240) :: grav_file, moho_out, thick_grid_out, topo_file, &
                      misfit_file, infile

    ! Path to example data files may be passed as first argument, or use a default.
    if (command_argument_count() > 0) then
        call get_command_argument(1, infile)
    else
        infile = "../../ExampleDataFiles"
    end if

    grav_file = trim(infile) // "/gmm3_120_sha.tab"
    topo_file = trim(infile) // "/MarsTopo719.shape"

    ! A data input file may be passed as second argument, or else prompt for required settings.
    if (command_argument_count() > 1) then
        call get_command_argument(2, infile)
        open(unit=20, file=infile, action="read")
        read(20,*) rho_crust
        read(20,*) rho_mantle
        read(20,*) filter_type
        if (filter_type /= 0 ) then
            read(20,*) half
        end if
        read(20,*) r1
        read(20,*) degmax
        read(20,*) t0
        read(20,*) moho_out
        read(20,*) interval
        read(20,*) thick_grid_out
        read(20,*) misfit_file
        close(20)
    else
        print*,  "rho_crust (kg/m3) > "
        read(*,*) rho_crust
        print*, "rho_mantle (kg/m3) > "
        read(*,*) rho_mantle

        print*, "Input filter type (1) Minimum amplitude, (2) minimum curvature, (0) no filter "
        read(*,*) filter_type
        if (filter_type /= 0 ) then
            print*, "Degree at which the filter is 1/2 "
            read(*,*) half
        end if

        print*, "Remove degree 1 topo coefficients from Bouguer Correction? (0:no, 1:yes) > "
        read(*,*) r1

        print*, "maximum degree to compute Moho relief to >"
        read(*,*) degmax

        print*, "Minimum assumed crustal thickness (km) > "
        read(*,*) t0

        print*, "Moho spherical harmonic coeficient output filename > "
        read(*,*) moho_out
        print*, "Grid spacing for output crustal thickness map (degrees) > "
        read(*,*) interval
        print*, "gridded crustal thickness output filename >"
        read(*,*) thick_grid_out
        print*, "Gravity misfit spherical harmonic filename >"
        read(*,*) misfit_file
    end if

    pi = acos(-1.0_dp)
    delta_max = 5.0_dp
    grav = Grav_constant

    gridtype = 3
    if (gridtype == 2) then
        sampling = 1
    else if (gridtype == 3) then
        sampling = 2
    else
        stop
    end if

    nmax = 7    ! nmax of Wieczorek and Phillips (1998)

    lmax = 2 * degmax ! this partially takes into account aliasing problems. Technically, it should be nmax*degmax

    nlat = 2 * lmax + 2
    nlong = 2 * nlat
    t0 = t0 * 1.0e3_dp

    call cpu_time(timein)

    allocate(topo_grid(nlat, nlong), stat = astat(1))
    allocate(moho_grid(nlat, nlong), stat = astat(2))
    allocate(moho_grid2(nlat, nlong), stat = astat(3))
    allocate(moho_grid3(nlat, nlong), stat = astat(4))
    allocate(temp_grid(nlat, nlong), stat = astat(5))
    allocate(topo_c(2,degmax+1,degmax+1), stat = astat(6))
    allocate(moho_c(2,degmax+1,degmax+1), stat = astat(7))
    allocate(bc(2,degmax+1,degmax+1), stat = astat(8))
    allocate(ba(2,degmax+1,degmax+1), stat = astat(9))
    allocate(cilm(2,degmax+1,degmax+1), stat = astat(10))
    allocate(pot(2,degmax+1,degmax+1), stat = astat(11))
    allocate(misfit(2,degmax+1,degmax+1), stat = astat(12))

    if (sum(astat(1:12)) /= 0) then
        print*, "Problem allocating arrays."
        stop
    end if

    !--------------------------------------------------------------------------
    !
    !    Read topo and grav files
    !
    !--------------------------------------------------------------------------

    print*, "Reading data from ", grav_file
    call SHRead(grav_file, pot, lmaxp, header=param(1:2))

    gm = param(2) * 1.e9_dp
    r_grav = param(1) * 1.e3_dp
    mass = gm/grav

    print*, "Mass (kg) = ", mass
    print*, "Average surface gravity (m/s2) = ", gm/r_grav**2
    print*, "Lmax of gravitational potential file = ", lmaxp

    print*, "Reading data from ", topo_file
    call SHRead(topo_file, topo_c, lmaxt)
    print*, "Lmax of topography file = ", lmaxt

    r0 = topo_c(1,1,1)
    print*, "r0 (km) = ", r0 / 1.e3_dp

    ! Downward continue gravity coefficients from 3397 to MPR

    do l  =2, lmaxp
        pot(1:2,l+1,1:l+1) = pot(1:2,l+1,1:l+1) * (r_grav/r0)**l
    end do

    !--------------------------------------------------------------------------
    !
    !    Create Bouger anomaly up to degree nmax
    !
    !--------------------------------------------------------------------------

    print*, "Creating Bouger anomaly"

    call MakeGridDH(topo_grid, n_out, topo_c, lmax, norm = 1, &
                    sampling = sampling, csphase = 1, lmax_calc = degmax)

    print*, "Maximum Topo (km) = ", maxval(topo_grid(1:nlat, 1:nlong)) / 1.e3_dp
    print*, "Minimum Topo (km) = ", minval(topo_grid(1:nlat, 1:nlong)) / 1.e3_dp

    call CilmPlus(bc, topo_grid, degmax, nmax, mass, rref, rho_crust, &
                  gridtype, n = nlat)

    ba = pot - bc    ! This is the bouguer anomaly

    if (r1 == 1) ba(1:2,2,1:2) = 0.0_dp

    !--------------------------------------------------------------------------
    !
    !    Compute crustal thickness by iterating at each
    !    reference moho depth. Gravity anomalies are calculated
    !    using n*lmax coefficients, but only the first lmax are
    !    used in the crustal thickness calculations.
    !
    !--------------------------------------------------------------------------

    d = r0 - 44.0e3_dp        ! initial reference moho depth

    thick_delta = 1.e9_dp

    do while (abs(thick_delta) > delta_max)

        write(*,*)
        print*, "Reference depth (km) = ", (r0-d) / 1.e3_dp

        moho_c(1,1,1) = d

        ! first iteration
        do l = 1, degmax
            if (filter_type == 0) then
                moho_c(1:2,l+1,1:l+1) = ba(1:2,l+1,1:l+1) * mass &
                                        * dble(2*l+1) * ((r0/d)**l) &
                                        / (4.0_dp *pi * (rho_mantle-rho_crust) * d**2)
            else if (filter_type == 1) then
                moho_c(1:2,l+1,1:l+1) = downcontfilterma(l, half, r0, d) &
                                        * ba(1:2,l+1,1:l+1) * mass &
                                        * dble(2*l+1) * ((r0/d)**l) &
                                        / (4.0_dp * pi * (rho_mantle-rho_crust) * d**2)
            else if (filter_type == 2) then
                moho_c(1:2,l+1,1:l+1) = downcontfiltermc(l, half, r0, d) &
                                        * ba(1:2,l+1,1:l+1) * mass &
                                        * dble(2*l+1) * ((r0/d)**l) &
                                        / (4.0_dp * pi * (rho_mantle-rho_crust) * d**2)
            end if
        end do

        call MakeGridDH(moho_grid3, n_out, moho_c, lmax, norm = 1, &
                        sampling = sampling, csphase = 1, lmax_calc = degmax)

        max_thick = maxval(topo_grid(1:nlat, 1:nlong) - moho_grid3(1:nlat, 1:nlong))
        min_thick = minval(topo_grid(1:nlat, 1:nlong) - moho_grid3(1:nlat, 1:nlong))
        print*, "Maximum Crustal thickness (km) = ", max_thick / 1.e3_dp
        print*, "Minimum Crustal thickness (km) = ", min_thick / 1.e3_dp

        ! second iteration
        if (filter_type == 0) then
            call BAtoHilm(moho_c, ba, moho_grid3, lmax, nmax, mass, r0, &
                          rho_mantle-rho_crust, gridtype, lmax_calc = degmax)
        else
            call BAtoHilm(moho_c, ba, moho_grid3, lmax, nmax, mass, r0, &
                          rho_mantle-rho_crust, gridtype, &
                          filter_type=filter_type, filter_deg=half, &
                          lmax_calc = degmax)
        end if
        call MakeGridDH(moho_grid2, n_out, moho_c, lmax, norm = 1, &
                        sampling = sampling, csphase = 1, lmax_calc = degmax)

        delta = maxval(abs(moho_grid3(1:nlat, 1:nlong) - moho_grid2(1:nlat, 1:nlong)))
        print*, "Delta (km) = ", delta / 1.e3_dp

        temp_grid(1:nlat, 1:nlong) = topo_grid(1:nlat, 1:nlong) &
                                     - moho_grid2(1:nlat, 1:nlong)
        max_thick = maxval(temp_grid(1:nlat, 1:nlong))
        min_thick = minval(temp_grid(1:nlat, 1:nlong))
        print*, "Maximum Crustal thickness (km) = ", max_thick / 1.e3_dp
        print*, "Minimum Crustal thickness (km) = ", min_thick / 1.e3_dp

        iter = 0
        delta = 1.0e9_dp

        do while(delta > delta_max)

            iter = iter + 1
            print*, "Iteration ", iter

            moho_grid(1:nlat,1:nlong) = (moho_grid2(1:nlat,1:nlong) &
                                        + moho_grid3(1:nlat,1:nlong)) / 2.0_dp

            delta = maxval(abs(moho_grid(1:nlat, 1:nlong) - moho_grid2(1:nlat, 1:nlong)))
            print*, "Delta (km) = ", delta / 1.e3_dp

            temp_grid(1:nlat, 1:nlong) = topo_grid(1:nlat, 1:nlong) - moho_grid(1:nlat, 1:nlong)
            max_thick = maxval(temp_grid(1:nlat, 1:nlong))
            min_thick = minval(temp_grid(1:nlat, 1:nlong))
            print*, "Maximum Crustal thickness (km) = ", max_thick / 1.e3_dp
            print*, "Minimum Crustal thickness (km) = ", min_thick / 1.e3_dp

            moho_grid3(1:nlat, 1:nlong) = moho_grid2(1:nlat, 1:nlong)
            moho_grid2(1:nlat, 1:nlong) = moho_grid(1:nlat, 1:nlong)

            iter = iter +1
            print*, "Iteration ", iter

            if (filter_type == 0) then
                call BAtoHilm(moho_c, ba, moho_grid2, lmax, nmax, mass, r0, &
                              rho_mantle-rho_crust, gridtype, &
                              lmax_calc = degmax)
            else
                call BAtoHilm(moho_c, ba, moho_grid2, lmax, nmax, mass, r0, &
                              rho_mantle-rho_crust, gridtype, &
                              filter_type=filter_type, filter_deg=half, &
                              lmax_calc = degmax)
            end if
            call MakeGridDH(moho_grid, n_out, moho_c, lmax, norm = 1, &
                            sampling = sampling, csphase = 1, lmax_calc = degmax)

            delta = maxval(abs(moho_grid(1:nlat, 1:nlong) - moho_grid2(1:nlat, 1:nlong)))
            print*, "Delta (km) = ", delta / 1.e3_dp

            temp_grid(1:nlat, 1:nlong) = topo_grid(1:nlat, 1:nlong) - moho_grid(1:nlat, 1:nlong)
            max_thick = maxval(temp_grid(1:nlat, 1:nlong))
            min_thick = minval(temp_grid(1:nlat, 1:nlong))
            print*, "Maximum Crustal thickness (km) = ", max_thick / 1.e3_dp
            print*, "Minimum Crustal thickness (km) = ", min_thick / 1.e3_dp

            moho_grid3(1:nlat, 1:nlong) = moho_grid2(1:nlat, 1:nlong)
            moho_grid2(1:nlat, 1:nlong) = moho_grid(1:nlat, 1:nlong)

            if (max_thick > 100.e3_dp) then
                print*, "Not converging"
                stop
            end if

        end do

        d = d + (min_thick - t0)
        thick_delta  = min_thick - t0

    end do

    thinnest(1:2) = minloc(temp_grid(1:nlat, 1:nlong))
    if (gridtype == 2) then
        print*, "Location of thinnest crust (lat, long) = ", &
            90.0_dp - dble((thinnest(1) - 1)) * 180.0_dp / dble(nlat), &
            dble(thinnest(2)-1)*360.0_dp / dble(nlat)
    else if(gridtype == 3) then
        print*, "Location of thinnest crust (lat, long) = ", &
            90.0_dp - dble((thinnest(1) - 1)) * 180.0_dp / dble(nlat), &
            dble(thinnest(2)-1)*180.0_dp / dble(nlat)
    end if

    !--------------------------------------------------------------------------
    !
    !    Determine misfit between observed and calculated gravity, and write
    !    data to external files. Note that here, only coefficients up to lmax
    !    are considered.
    !
    !--------------------------------------------------------------------------

    call CilmPlus(cilm, moho_grid, degmax, nmax, mass, rref, &
                  rho_mantle-rho_crust, gridtype, n=nlat)

    ! upward continue moho coefficients
    do l = 0, degmax
        cilm(1:2,l+1,1:l+1) = cilm(1:2,l+1,1:l+1) * (d/r0)**l
    end do

    misfit = pot - (bc + cilm)     ! this is the misfit
    misfit(1,1,1) = 0.0_dp        ! ignore degree-0 misfit

    do l = 0, degmax
        cilm(1:2,l+1,1:l+1) = misfit(1:2,l+1,1:l+1) * dble(l+1.0_dp) * gm &
                              * (1.0e5_dp) / r0**2
    end do

    call MakeGridDH(temp_grid, n_out, cilm, lmax, norm = 1, &
                    sampling = sampling, csphase = 1, lmax_calc = degmax)

    print*, "Maximum misfit (mgals) = ", maxval(temp_grid(1:nlat, 1:nlong))
    print*, "Minimum misfit (mgals) = ", minval(temp_grid(1:nlat, 1:nlong))

    print*, "Mean Crustal Thickness (km) =", (r0-moho_c(1,1,1)) / 1.e3_dp

    print*, "Writing output data"

    open(12,file=moho_out)

    do l = 0,degmax
        do m = 0,l
            write(12,*) l, m, moho_c(1,l+1,m+1), moho_c(2,l+1,m+1)
        end do
    end do

    close(12)

    call MakeGrid2d(topo_grid, topo_c - moho_c, degmax, interval, nlat, nlong)

    open(12, file=thick_grid_out)
    write(12,*) nlat, nlong
    do i = 1, nlat
        do j = 1, nlong
            write(12,*) topo_grid(i,j) / 1.e3_dp
        end do
    end do

    close(12)

    open(12, file=misfit_file)
    do l = 0, degmax
        do m = 0, l
            write(12,*) l, m, misfit(1,l+1,m+1), misfit(2,l+1,m+1)
        end do
    end do

    close(12)

    deallocate(topo_grid)
    deallocate(moho_grid)
    deallocate(moho_grid2)
    deallocate(moho_grid3)
    deallocate(temp_grid)
    deallocate(topo_c)
    deallocate(moho_c)
    deallocate(bc)
    deallocate(ba)
    deallocate(cilm)
    deallocate(pot)
    deallocate(misfit)

    call cpu_time(timeout)
    print*, "time (sec) = ", timeout-timein

end program MarsCrustalThickness

program TestCilmPlus
!------------------------------------------------------------------------------
!
!    This program will
!
!    (1) Read in a spherical harmonic file of maximum degree Lmax, expand it in
!        the spatial domain, and then re-expand it into spherical harmonics
!        using Guass-Legendre quadrature. The relativive errors in the space
!        and spectral domaines will be determined.
!    (2) Using these routines, the potential coefficients will be computed
!        according to the algorithm of Wieczorek and Phillips (1998). The
!        maximum order of the exspansion will be determined as well.
!    (3) The difference between using nmax*lmax coefficients when calculating
!        the gravity coefficients vs. n*lmax will be determined.
!    (4) A 2d gridded data file of the input coefficients with equal latitude
!        and longitude spacings) will be output.
!
!    Notes: The only two parameters in this program that might want
!    to be changed is MAX and MAX2DGRID. The first sets the maximum
!    degree that can be computed in the spherical harmonic expansions,
!    while the second sets the maximum size of the output 2d grid.
!
!    Comments on compiling and modifying this code:
!
!    1. This example code uses a lot of memory, and runs slowly in order to
!    demonstrate the accuracy of the routines. It may be necessary to compile
!    it with the -s option (static memory). Also, if memory is not an issue,
!    then the arrays plx and plxn should be precomputed.
!    2. As is seen in the output, for Mars (and also the Moon) nmax should be
!    about 5 in order to achieve an accuracy comparable to the spherical
!    harmonic model.
!    3. In order to exactly calculate the gravity field using the Wieczorek
!    and Phillips (1998) method, if the original field is defined up to lmax,
!    the final output field should be nmax*lmax. This is achieved in practice
!    by zero padding the input field from lmax+1 to nmax*lmax+1. However, as is
!    seen in the output, in practice, it is only necessary to increase the size
!    of the input field by about 50%. At the same time, since the topography
!    spherical harmonic coefficients are NOT really zero beyond lmax, zero
!    padding between (lmax+1, and nmax*lmax+1) still only yields an
!    approximation to the gravity field. This would only be strictly correct
!    if the topography was bandlimited to degree lmax.
!
!    Copyright (c) 2005, SHTOOLS
!    All rights reserved.
!
!------------------------------------------------------------------------------
    use SHTOOLS
    use PlanetsConstants
    use ftypes

    implicit none

    integer, parameter :: degmax = 650, max2dgrid = 181
    real(dp) :: zero(degmax+1), w(degmax+1), c1ilm(2, degmax+1, degmax+1), &
                zeron(degmax+1), wn(degmax+1), cilm(2, degmax+1, degmax+1), &
                c2ilm(2,degmax+1, degmax+1), grid1glq(degmax+1, 2*degmax+1), &
                gridglq(degmax+1, 2*degmax+1), grid2glq(degmax+1, 2*degmax+1), &
                grid3glq(degmax+1, 2*degmax+1), pi, maxerror, err1, err2, &
                d, rho, mass, grav, gm, grid2d(max2dgrid, 2*max2dgrid), &
                interval, timein, timeout
    real(dp), allocatable :: plxn(:,:),  plx(:,:)
    integer(int32) :: lmax, i, j, l, m, nlat, nlong, nmax, n, astat, &
                      lmaxfile, lmaxn, nlatn, nlongn, precomputeplx
    character(240) :: infile, outfile

    call cpu_time(timein)

    pi = acos(-1.0_dp)

    rho = 2900.0_dp            ! assumed crustal density
    grav = Grav_Constant
    gm = GM_Mars
    mass = Mass_Mars

    precomputeplx = 0            ! set to 1 precompute arrays PLXN and PLX

    !print*, "Spherical Harmonic file > "
    !read(*,*) infile
    ! Path to example data files may be passed as first argument, or use a default.
    if (command_argument_count() > 0) then
        call get_command_argument(1, infile)
    else
        infile = "../../ExampleDataFiles"
    end if
    infile = trim(infile) // "/MarsTopo719.shape"

    !print*, "Maximum degree to read > "
    !read(*,*) lmax
    lmax = 90

    if (precomputeplx == 1) then
        allocate (plx(lmax+1, (lmax+1)*(lmax+2)/2), stat = astat)
        if (astat /=0) then
            print*, "Problem allocating plx"
            stop
        end if
    end if

    if (lmax > degmax) then
        print*, "lmax must be less than or equal to , ", degmax
        print*, "Change max and recompile"
        stop
    end if

    nlat = NGLQSH(lmax)     ! These are the sizes of the grids used in (lmax+1)
    nlong = 2 * lmax + 1    ! the gauss-legendre quadtrature routines

    !--------------------------------------------------------------------------
    !
    !    Read Spherical harmonic coefficients
    !
    !--------------------------------------------------------------------------

    call SHRead(infile, cilm, lmaxfile)

    print*, "Input file name = ", infile
    print*, "Maximum degree of input file = ", lmaxfile
    print*, "Maximum degree used in the calculations = ", lmax
    if (lmaxfile > lmax) then
        cilm(:,lmax+2:lmaxfile+1,lmax+2:lmaxfile+1) = 0.0_dp
        ! zero coefficients greater than lmax
    end if

    !--------------------------------------------------------------------------
    !
    !    Call a routine which will compute a number of arrays that will be
    !    used later on (these include the guass points, weights, and plx).
    !
    !--------------------------------------------------------------------------

    print*, "Precomputing data structures..."

    if (precomputeplx == 1) then
        call SHGLQ(lmax, zero, w, plx = plx)
    else
        call SHGLQ(lmax, zero, w)
    end if

    !--------------------------------------------------------------------------
    !
    !    Compute a grid from the spherical harmonic coefficients.
    !    Note that this grid is equally spaced in longitude,
    !    but unevenly space in latitude according to the gauss points.
    !
    !--------------------------------------------------------------------------

    print*, "Making Grid..."

    if (precomputeplx == 1) then
        call MakeGridGLQ(gridglq, cilm, lmax, plx = plx)
    else
        call MakeGridGLQ(gridglq, cilm, lmax, zero = zero)
    end if

    !--------------------------------------------------------------------------
    !
    !    This routine expands the grid into spherical harmonics
    !
    !--------------------------------------------------------------------------

    print*, "Expanding into spherical harmonics"

    if (precomputeplx == 1) then
        call SHExpandGLQ(c2ilm, lmax, gridglq, w, plx = plx)
    else
        call SHExpandGLQ(c2ilm, lmax, gridglq, w, zero = zero)
    end if

    !--------------------------------------------------------------------------
    !
    !    Next, compute relative errors between the original and
    !    computed spherical harmonic coefficients
    !
    !--------------------------------------------------------------------------

    maxerror = 0.0_dp
    do l = 0, lmax
        do m = 0, l
            if (m == 0) then
                err1 = abs(cilm(1,l+1,m+1)-c2ilm(1,l+1,m+1)) / abs(cilm(1,l+1,m+1))
                if (err1 >= maxerror) maxerror = err1
            else
                err1 = abs(cilm(1,l+1,m+1) - c2ilm(1,l+1,m+1)) / abs(cilm(1,l+1,m+1))
                err2 = abs(cilm(2,l+1,m+1) - c2ilm(2,l+1,m+1)) / abs(cilm(2,l+1,m+1))
                if (err1 >= maxerror) maxerror = err1
                if (err2 >= maxerror) maxerror = err2
            end if
        end do
    end do

    print*, "Maximum relative error between spherical harmonic coefficients = ", maxerror

    !--------------------------------------------------------------------------
    !
    !    Next, compute the maximum error in the space domain
    !    at the gauss points.
    !
    !--------------------------------------------------------------------------

    if (precomputeplx == 1) then
        call MakeGridGLQ(grid2glq, &
                         cilm(:,1:lmax+1,1:lmax+1) - c2ilm(:,1:lmax+1,1:lmax+1), &
                         lmax, plx = plx)
    else
        call MakeGridGLQ(grid2glq, &
                         cilm(:,1:lmax+1,1:lmax+1)-c2ilm(:,1:lmax+1,1:lmax+1), &
                         lmax, zero = zero)
    end if

    print*, "Maximum error (meters) at the gauss points = ", maxval(abs(grid2glq(1:nlat,1:nlong)))

    !--------------------------------------------------------------------------
    !
    !    Compute the potential coefficients due to the topography
    !    using nmax, and then determine the maximum difference between
    !    this gravity field and that calculated at a smaller n
    !    in the space domain. Note, even though the gravity field
    !    is calculated up to nmax*lmax, the differences that are
    !    output only correspond to the first lmax coefficients.
    !
    !    Note: the minimum gravity anomaly of Lemoine et al. (2001) is
    !    about 6 mgals. I have also determined that the the relative
    !    error for the Moho coefficients is smaller than that of the
    !    topography (The opposite is the case for the Moon). Thus the
    !    value of n used for the topography is sufficient for the moho as well.
    !
    !    The reason that the maximum degree of the spherical harmonic
    !    fields needs to be increased beyond lmax is that raising a field to
    !    the nth power results in a field with coefficients up to n*lmax.
    !
    !--------------------------------------------------------------------------

    nmax = 7
    lmaxn = lmax * nmax
    nlatn = NGLQSH(lmaxn)    ! These are the sizes of the grids used in (lmax+1)
    nlongn = 2 * lmaxn + 1     ! the gauss-legendre quadtrature routines

    print*, "Maximum spherical harmonic degree corresponding to n = ", nmax, " = ", lmaxn
    if (lmaxn > degmax ) then
        print*, "lmaxn is greater than max. Change max and recompile."
        stop
    end if

    if (precomputeplx == 1) then
        ! This must be called again since the value of lmax is different than above
        allocate (plxn(lmaxn+1, (lmaxn+1)*(lmaxn+2)/2), stat = astat)
        if (astat /=0) then
            print*, "Problem allocating plxn"
            stop
        end if
    end if

    print*, "Computing gravity coefficients..."
    if (precomputeplx == 1) then
        call SHGLQ(lmaxn, zeron, wn, plx = plxn)
        call MakeGridGLQ(gridglq, cilm, lmaxn, plx = plxn)
        call CilmPlus(c1ilm, gridglq, lmaxn, nmax, mass, d, rho, &
                      gridtype = 1, w = wn, plx = plxn)
    else
        call SHGLQ(lmaxn, zeron, wn)
        call MakeGridGLQ(gridglq, cilm, lmaxn, zero = zeron)
        call CilmPlus(c1ilm, gridglq, lmaxn, nmax, mass, d, rho, &
                      gridtype = 1, w = wn, zero = zeron)
    end if

    do l = 0, lmaxn
        c1ilm(:,l+1,1:l+1) = c1ilm(:,l+1,1:l+1) * (l+1.0_dp) * gm * (1.0e5_dp) / d**2
        ! convert to gravity coefficients in mgals
    end do

    do n = 1, nmax - 1

        if (precomputeplx == 1) then
            call CilmPlus(c2ilm, gridglq, lmaxn, n, mass, d, rho, &
                          gridtype = 1, w = wn, plx = plxn)
        else
            call CilmPlus(c2ilm, gridglq, lmaxn, n, mass, d, rho, &
                          gridtype = 1, w = wn, zero = zeron)
        end if

        do l = 0, lmaxn
            c2ilm(:,l+1,1:l+1) = c2ilm(:,l+1,1:l+1) * (l+1.0_dp) * gm * (1.0e5_dp) / d**2
        end do

        ! Compute difference only up to lmax, not lmaxn

        if (precomputeplx == 1) then
            call MakeGridGLQ(grid3glq, &
                c1ilm(:,1:lmax+1,1:lmax+1) - c2ilm(:,1:lmax+1,1:lmax+1), &
                lmax, plx = plx)
        else
            call MakeGridGLQ(grid3glq, &
                c1ilm(:,1:lmax+1,1:lmax+1) - c2ilm(:,1:lmax+1,1:lmax+1), &
                lmax, zero = zero)
        end if

        print*, "Maximum difference (mgals) between nmax = ", nmax, " and ", n, " = ", &
            maxval(abs(grid3glq(1:nlat,1:nlong)))

    end do

    !--------------------------------------------------------------------------
    !
    !    Next calculate the difference in the gravity field that arrises from
    !    doing the GLQ integrations with a field zero-padded up to lmaxn as
    !    opposed to nmax*lmax.
    !
    !--------------------------------------------------------------------------

    do n = 1, 10
        !lmaxn = lmax * n
        lmaxn = lmax + (n-1) * 10
        nlatn = NGLQSH(lmaxn)
        nlongn = 2 * lmaxn + 1

        if (precomputeplx == 1) then
            call SHGLQ(lmaxn, zeron, wn, plx = plxn)
            call MakeGridGLQ(gridglq, cilm, lmaxn, plx = plxn)
            call CilmPlus(c2ilm, gridglq, lmaxn, nmax, mass, d, rho, &
                          gridtype = 1, w = wn, plx = plxn)
        else
            call SHGLQ(lmaxn, zeron, wn)
            call MakeGridGLQ(gridglq, cilm, lmaxn, zero = zeron)
            call CilmPlus(c2ilm, gridglq, lmaxn, nmax, mass, d, rho, &
                          gridtype = 1, w = wn, zero = zeron)
        end if

        do l = 0, lmaxn
            c2ilm(:,l+1,1:l+1) = c2ilm(:,l+1,1:l+1) * (l+1.0_dp) * gm * (1.0e5_dp) / d**2
            ! convert to gravity coefficients in mgals
        end do

        ! Compute difference only up to lmax, not lmaxn

        if (precomputeplx == 1) then
            call MakeGridGLQ(grid1glq, &
                c1ilm(:,1:lmax+1,1:lmax+1)-c2ilm(:,1:lmax+1,1:lmax+1), &
                lmax, plx = plx)
        else
            call MakeGridGLQ(grid1glq, &
                c1ilm(:,1:lmax+1,1:lmax+1)-c2ilm(:,1:lmax+1,1:lmax+1), &
                lmax, zero = zero)
        end if

        print*, "Maximum difference (mgals) between using Lmax of expansion equal to ", lmax * nmax, " and LMAX = ", lmaxn, &
             maxval(abs(grid1glq(1:nlat,1:nlong)))

    end do

    !--------------------------------------------------------------------------
    !
    !    Calculate a 2d grid with equal longitude and latitude spacings.
    !    Note that if you want a grid finer than 1 degree, that you must
    !    increase the parameter maxgrid2d.
    !
    !--------------------------------------------------------------------------

    print*, "Making 2d grid with equal latitude and longitude spacings"
    interval = 2
    cilm(1,1,1) = 0.0_dp        ! set degree-zero term to zero
    cilm(1,3,1) = 0.0_dp        ! set j2 term to zero

    outfile = "grid2d.dat"
    open(12,file = outfile)

    call MakeGrid2d(grid2d, cilm, lmax, interval, nlat, nlong)

    write(12,*) nlat, nlong     ! header line giving the dimensions of the
                                ! following raster image
    do i = 1, nlat
        do j = 1, nlong
            write(12,*) grid2d(i,j)
        end do
    end do

    close(12)

    if (precomputeplx == 1) then
        deallocate(plx)
        deallocate(plxn)
    end if

    call cpu_time(timeout)
    print*, "time (sec) = ", timeout-timein

end program TestCilmPlus

Program TestExpandDH
!------------------------------------------------------------------------------
!
!    This program will expand a grid containing n samples in both longitude and
!    latitude into spherical harmonics using the sampling theorems given in
!    Driscoll and Heally (1994).
!
!    Copyright (c) 2005, SHTOOLS
!    All rights reserved.
!
!------------------------------------------------------------------------------
    use SHTOOLS
    use ftypes

    implicit none
    integer(int32), parameter :: maxdeg = 120, maxgrid = 800
    character(240) :: infile
    real(dp) :: cilm(2, maxdeg+1, maxdeg+1), grid(maxgrid, maxgrid), &
                griddh(maxgrid, maxgrid), cilm2(2, maxdeg+1, maxdeg+1), &
                interval, error, maxerror
    integer(int32) :: lmax, n, nlat, nlong, lmax2, l, m, i

    ! Path to example data files may be passed as first argument, or use a default.
    if (command_argument_count() > 0) then
        call get_command_argument(1, infile)
    else
        infile = "../../ExampleDataFiles"
    end if
    infile = trim(infile) // "/MarsTopo719.shape"

    call SHRead(infile, cilm, lmax)
    print*, "Lmax of data file = ", lmax

    !--------------------------------------------------------------------------
    !
    !     Create an equally sampled grid
    !
    !--------------------------------------------------------------------------

    lmax = 89
    print*, "For this test of SHExpandDH, the initial grid will be created with lmax = ", lmax

    interval = 1.0_dp

    print*, "Making grid using MakeGrid2D..."

    call MakeGrid2D(grid, cilm, lmax, interval, nlat, nlong)
    print*, "nlat, nlong = ", nlat, nlong

    print*, "Minimum and maximum values of the input grid = ", minval(grid(1:nlat, 1:nlong)), maxval(grid(1:nlat,1:nlong))

    n = nlat -1

    print*, "Number of samples in latitude used with SHExpandDH = ", n

    griddh(1:n,1:2*n) = grid(1:n, 1:2*n)

    !--------------------------------------------------------------------------
    !
    !    Expand equally spaced grid using Driscoll and Heally routine, and
    !    compute relative error between input and output spherical harmonic
    !    coefficients.
    !
    !--------------------------------------------------------------------------

    call SHExpandDH(griddh, n, cilm2, lmax2, sampling = 2)
    print*, "Lmax of Driscoll Heally expansion = ", lmax2

    maxerror = 0.0_dp

    do l = 0, lmax
        error = (cilm2(1,l+1,1)-cilm(1,l+1,1)) / cilm(1,l+1,1)
        if (error > maxerror) maxerror = error
        do m = 1, l, 1
            error = (cilm2(1,l+1,m+1)-cilm(1,l+1,m+1)) / cilm(1,l+1,m+1)
            if (error > maxerror) maxerror = error
            error = (cilm2(2,l+1,m+1)-cilm(2,l+1,m+1)) / cilm(2,l+1,m+1)
            if (error > maxerror) maxerror = error
        end do
    end do

    print*, "Maximum relative error between initial and output spherical harmonic coefficients = ", maxerror

    !--------------------------------------------------------------------------
    !
    !    Re-expand coefficients in the space domain, and compare
    !    with input grid.
    !
    !--------------------------------------------------------------------------

    griddh = 0.0_dp
    call MakeGridDH(griddh, n, cilm2, lmax2)
    print*, "Number of samples in latitude and longitude = ", n

    maxerror = 0.0_dp

    do i = 1, n
        error = maxval( abs( griddh(1:n,i) - grid(1:n, 2*i-1) ) )
        if (error > maxerror) maxerror = error
    end do

    print*, "Maximum error (meters) in the space domain = ", maxerror

end program TestExpandDH

program SHMag
!------------------------------------------------------------------------------
!
!    This program will read in a set of magnetic spherical harmonic
!    coefficients and make 2D equally spaced grid of the three vector
!    components of the magnetic field, the total magnetic field strength, and
!    the magnetic potential. The field is calculated on a speroid with mean
!    radius r and flattening f.
!
!    The included spherical harmonic file FSU_mars90.sh is the martian magnetic
!    field model of Cain et al., 2003.
!
!    Copyright (c) 2012, SHTOOLS
!    All rights reserved.
!
!------------------------------------------------------------------------------
    use SHTOOLS
    use ftypes

    implicit none

    character(240) :: infile, radf, thetaf, phif, totalf, potf
    real(dp) :: header(4), interval, r0, a, f, mpr, z, timein, timeout, temp
    real(dp), allocatable :: glm(:,:,:), rad(:,:), phi(:,:), theta(:,:), &
                             total(:,:), pot(:,:)
    integer(int32) :: lmax, lmaxp, n, n_out, nlong, nlat, i, j, astat(6), sampling

    ! Path to example data files may be passed as first argument, or use a default.
    if (command_argument_count() > 0) then
        call get_command_argument(1, infile)
    else
        infile = "../../ExampleDataFiles"
    end if
    infile = trim(infile) // "/FSU_mars90.sh"

    f = 1.0_dp / 169.864881_dp    ! Mars flattening = (R_eq - R_p)/R_eq
    mpr = 3389.508e3_dp           ! Mean radius of mars
    z = 145.e3_dp                 ! mean altitude to calculate field at.

    lmax = 359    ! Maximum spherical harmonic degree that is resolved in the output grids.
    N = 2 * lmax + 2    ! Number of latitudinal samples in the output grids.
    interval = 180.0_dp / dble(n)    ! Sampling interval in latitude.

    sampling = 2
    nlat = n
    nlong = 2 * n

    print*, "LMAX of output grids = ", lmax
    print*, "N = ", n
    print*, "Latitudinal sampling interval = ", interval

    allocate(glm(2,lmax+1,lmax+1), stat = astat(1))
    allocate(rad(nlat,nlong), stat = astat(2))
    allocate(theta(nlat,nlong), stat = astat(3))
    allocate(phi(nlat,nlong), stat = astat(4))
    allocate(total(nlat,nlong), stat = astat(5))
    allocate(pot(nlat,nlong), stat = astat(6))

    if (sum(astat(1:6)) /= 0) then
        print*, "Problem allocating GLM, RAD, THETA, PHI, TOTAL, and POT", &
            astat(1), astat(2), astat(3), astat(4), astat(5), astat(6)
        stop
    end if

    call SHRead(infile, glm, lmaxp, header=header(1:4), skip=1)
    r0 = header(1) * 1.e3_dp
    print*, "Reference radius of spherical harmonic coefficients R0 (km) = ", r0 / 1.e3_dp
    print*, "Lmax of spherical harmonic model = ", lmaxp

    a = mpr + z
    print*, "Field calculated on a flattened ellipsoid with semi-major axis A (km) = ", a / 1.e3_dp
    print*, "Flattening of the ellipsoid = ", f

    radf = "radial_145f.dat"
    thetaf = "theta_145f.dat"
    phif = "phi_145f.dat"
    totalf = "total_145f.dat"
    potf = "pot_145f.dat"

    call cpu_time(timein)

    call MakeMagGridDH(glm, lmax, r0, a, f, rad, theta, phi, total, n_out, &
                       sampling = sampling, lmax_calc = lmaxp, pot_grid = pot)

    call cpu_time(timeout)

    print*, "Elapsed time (sec) = ", timeout-timein

    if (n /= n_out) then
        print*, "Problem. N is not equal to N_OUT."
        print*, "N_OUT = ", n_out
        stop
    end if

    print*, "Maximum and minimum field intensity (nT) = ", maxval(total(1:nlat,1:nlong)), minval(total(1:nlat,1:nlong))
    print*, "Maximum and minimum Br (nT) = ", maxval(rad(1:nlat,1:nlong)), minval(rad(1:nlat,1:nlong))
    print*, "Maximum and minimum Btheta (nT) = ", maxval(theta(1:nlat,1:nlong)), minval(theta(1:nlat,1:nlong))
    print*, "Maximum and minimum Bphi (nT) = ", maxval(phi(1:nlat,1:nlong)), minval(phi(1:nlat,1:nlong))
    print*, "Maximum and minimum potential (nT m) = ", maxval(pot(1:nlat,1:nlong)), minval(pot(1:nlat,1:nlong))

    open(12,file=radf)
    open(13,file=phif)
    open(14,file=thetaf)
    open(15,file=totalf)
    open(16,file=potf)

    write(12,*) nlat+1, nlong+1
    write(13,*) nlat+1, nlong+1
    write(14,*) nlat+1, nlong+1
    write(15,*) nlat+1, nlong+1
    write(16,*) nlat+1, nlong+1

    do i = 1, nlat
        do j = 1, nlong
            write(12,*) rad(i,j)
            write(13,*) phi(i,j)
            write(14,*) theta(i,j)
            write(15,*) total(i,j)
            write(16,*) pot(i,j)
        end do
        ! write out value at 360 degrees longitude, which is redundant
        write(12,*) rad(i,1)
        write(13,*) phi(i,1)
        write(14,*) theta(i,1)
        write(15,*) total(i,1)
        write(16,*) pot(i,1)
    end do

    ! write out values at 90 S, which are not calculated in the Driscoll and
    ! Healy routine, and which are just the average of the values of the last row.
    temp = sum(rad(nlat,1:nlong)) / dble(nlong)
    do j = 1, nlong + 1
        write(12,*) temp
    end do
    temp = sum(phi(nlat,1:nlong)) / dble(nlong)
    do j = 1, nlong + 1
        write(13,*) temp
    end do
    temp = sum(theta(nlat,1:nlong)) / dble(nlong)
    do j = 1, nlong + 1
        write(14,*) temp
    end do
    temp = sum(total(nlat,1:nlong)) / dble(nlong)
    do j = 1, nlong + 1
        write(15,*) temp
    end do
    temp = sum(pot(nlat,1:nlong)) / dble(nlong)
    do j = 1, nlong + 1
        write(16,*) temp
    end do

    close(12)
    close(13)
    close(14)
    close(15)
    close(16)

    deallocate(rad)
    deallocate(theta)
    deallocate(phi)
    deallocate(total)
    deallocate(pot)
    deallocate(glm)

end program SHMag

program TestSHExpandLSQ
!------------------------------------------------------------------------------
!
!    This program will (1) create a set of unevenly spaced data points from a
!    spherical harmonic file, and then (2) expand these into spherical
!    harmonics using a least-squares inversion if there are more data points
!    than spherical harmonic coefficients (overdetermined case), or using a
!    minimum norm solution if there are more coefficients than data points
!    (underdetermined case).
!
!    Copyright (c) 2005, SHTOOLS
!    All rights reserved.
!
!------------------------------------------------------------------------------
    use SHTOOLS
    use ftypes

    implicit none

    integer, parameter :: dmax = 10000, degmax = 120
    real(dp) :: d(dmax), lat(dmax), lon(dmax), cilm(2,degmax+1, degmax+1), &
                x, y, z, pi, maxerror, cilm1(2,degmax+1, degmax+1), &
                dd(dmax), misfit
    integer(int32) :: nmax, lmax, l, i, seed, lmaxfile
    character(240) :: infile

    d = 0.0_dp
    dd = 0.0_dp
    lon = 0.0_dp
    lat = 0.0_dp
    pi = acos(-1.0_dp)

    ! Path to example data files may be passed as first argument, or use a default.
    if (command_argument_count() > 0) then
        call get_command_argument(1, infile)
    else
        infile = "../../ExampleDataFiles"
    end if
    infile = trim(infile) // "/MarsTopo719.shape"

    call SHRead(infile, cilm, lmaxfile)
    print*, "Maximum degree of spherical harmonic file = ", lmaxfile

    ! A data input file may be passed as second argument, or else prompt for required settings.
    if (command_argument_count() > 1) then
        call get_command_argument(2, infile)
        open(unit=20, file=infile, action="read")
        read(20,*) nmax
        close(20)
    else
        print*, "Number of random data points to use > "
        read(*,*) nmax
    end if

    lmax = floor(sqrt(dble(nmax)) - 1)
    print*, "Maximum spherical harmonic degree for overdetermined least-squares inversion = ", lmax

    !--------------------------------------------------------------------------
    !
    !    Create synthetic data from the known spherical harmonic coefficients.
    !    Data points are located at random points on the sphere.
    !
    !--------------------------------------------------------------------------

    seed = -13453

    do i = 1, nmax
        x = 2.0_dp * RandomN(seed) - 1.0_dp
        y = 2.0_dp * RandomN(seed) - 1.0_dp
        z = 2.0_dp * RandomN(seed) - 1.0_dp
        lat(i) = atan2(z, sqrt(x**2 + y**2)) * 180.0_dp  /pi
        lon(i) = atan2(y, x) * 180.0_dp / pi
        d(i) = MakeGridPoint(cilm, lmaxfile, lat(i), lon(i), norm=1)
    end do

    print*, "maximum (km) = ", maxval(d(1:nmax)) / 1.e3_dp
    print*, "minimum (km) = ", minval(d(1:nmax)) / 1.e3_dp

    !--------------------------------------------------------------------------
    !
    !    Do least squares inversion for increasing values of l.
    !
    !--------------------------------------------------------------------------

    do l = 1, lmax, 1

        print*, "l = ", l

        call SHExpandLSQ(cilm1, d(1:nmax), lat(1:nmax), lon(1:nmax), nmax, &
                         l, norm=1, chi2=misfit)

        do i = 1, nmax
            dd(i) = MakeGridPoint(cilm1, l, lat(i), lon(i), norm=1)
        end do

        maxerror = maxval(abs(d(1:nmax) - dd(1:nmax)))

        print*, "Maximum error between input and output data points (km) = ", maxerror / 1.e3_dp
        print*, "Sum of squares residuals (km^2) = ", misfit / 1.e6_dp

    end do

end program TestSHExpandLSQ
